Bug 257692 - [NEW PORT] x11/xfce4-docklike-plugin A modern, minimalist taskbar for Xfce
Summary: [NEW PORT] x11/xfce4-docklike-plugin A modern, minimalist taskbar for Xfce
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Some People
Assignee: Guido Falsi
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2021-08-08 21:49 UTC by Quentin Baker
Modified: 2021-08-15 17:25 UTC (History)
3 users (show)

See Also:


Attachments
Port Patchfile (3.96 KB, patch)
2021-08-08 21:49 UTC, Quentin Baker
no flags Details | Diff
New diff with requested changes (4.18 KB, patch)
2021-08-10 20:41 UTC, Quentin Baker
no flags Details | Diff
New diff with requested changes (4.17 KB, patch)
2021-08-10 20:50 UTC, Quentin Baker
no flags Details | Diff
Updated patch (4.38 KB, patch)
2021-08-14 19:41 UTC, Guido Falsi
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Quentin Baker 2021-08-08 21:49:44 UTC
Created attachment 227025 [details]
Port Patchfile

An XFCE Plugin that adds a windows-10-esque taskbar with features like pinnable applications, grouped windows, desktop applications, and window previews (optional).

Main source: https://gitlab.xfce.org/panel-plugins/xfce4-docklike-plugin
Comment 1 Quentin Baker 2021-08-08 21:54:23 UTC
Poudrerie `porttest` is in progress. I tested using the suggestions from https://docs.freebsd.org/en/books/porters-handbook/book/#porting-testing in the meantime.
Comment 2 Quentin Baker 2021-08-10 00:16:24 UTC
(In reply to Quentin Baker from comment #1)
Update: I don't have a good enough machine (not enough RAM + SWAP) to do a testbuild -- rust and llvm blow up. I will try a synth test build with prebuilt dependencies.

If it is enough of a necessity for a poudriere log, I would ask someone with the hardware available consider stepping in or I could ask for an exp-run
Comment 3 Guido Falsi freebsd_committer 2021-08-10 07:52:41 UTC
Hi!

Thanks for the submission.

To your question, the poudriere log is useful but if it is necessary is a little opinionated AFAIK.

If I'm going to commit this I'm going to perform my own testing in my poudriere anyway, so you can spare it if it's a problem for you, as long as you have tested the port properly regarding the other parts.

I can look into this but not right away, please be patient and I will get to this in a few days.

Also, once this is added to the ports tree, you'd like to be added to the additional contributors list? [1]

I don't see you there. You'd get there with full name and email address you registered here.

(reassigning this to xfce@ since it looks appropriate)


[1] https://docs.freebsd.org/en/articles/contributors/#contrib-additional
Comment 4 Guido Falsi freebsd_committer 2021-08-10 07:54:23 UTC
I forgot I have another question for you:

I see the github repo you pint to is a fork of another repo.

What's the difference?

Why the fork is to be preferred?
Comment 5 Quentin Baker 2021-08-10 08:01:12 UTC
(In reply to Guido Falai from comment #3)
No rush, I understand. I honestly was a bit surprised it had someone already looking at the ticket. And yes, feel free to add my name and email as currently shown on bugzilla. 

(In reply to Guido Falsi from comment #4)
davekeogh's repo is the base for the official one hosted on XFCE's GitLab instance, and has some important fixes and additional features: https://gitlab.xfce.org/panel-plugins/xfce4-docklike-plugin

I use the github source because USE_GITLAB appears to be unable to fetch from gitlab repositories hosted under a project (Panel Plugins) rather than an individual account.
Comment 6 Guido Falsi freebsd_committer 2021-08-10 08:05:00 UTC
(In reply to Quentin Baker from comment #5)

Thanks for the feedback.

Getting the sources from xfce own gitlab instance would be "more official", so a better choice, eventually I'll see if it can be done.
Comment 7 Quentin Baker 2021-08-10 08:06:18 UTC
(In reply to Guido Falsi from comment #6)
Sure. If you think its worth doing, I can mess around with the USE_GITLAB use fields and file a report if I can see why its failing.
Comment 8 Guido Falsi freebsd_committer 2021-08-10 09:44:10 UTC
(In reply to Quentin Baker from comment #7)

In the while I noticed some issues by skimming you submission patch:

instead of doing:

DISTVERSION=	v0.3.0

you should use:

PORTVERSION=    0.3.0
DISTVERSIONPREFIX=      v

This could also help with gitlab.


Another issue, usually lib depends are distributed one per line like this:

LIB_DEPENDS=	libinotify.so:devel/libinotify \
		libharfbuzz.so:print/harfbuzz

USES and _USE lines content should be sorted

The pkg-descr should be expanded. It makes little sense to have the same text in the port COMMENT (which requires a very succinct description) and the pkg-descr which should expand on what the software actually does. Could you rewrite the pkg-descr with a more thorough description? You can also copy it from upstream, but it has to be something more than the COMMENT content.

Also I have some perplexity about the LDFLAGS you added, maybe a patch to the Makefile or configure script would be better, but for this last one testing is needed to decide the best solution.
Comment 9 Quentin Baker 2021-08-10 20:41:16 UTC
Created attachment 227093 [details]
New diff with requested changes

Alphabetized USE/USES fields, expanded pkg-desc
Comment 10 Quentin Baker 2021-08-10 20:41:53 UTC
(In reply to Guido Falsi from comment #8)
I have added an updated patch that alphabetizes the USE/USES fields and expands the pkg-desc.

The LDFLAGS line comes from the suggestion of implementation by libinotify-kqueue: https://github.com/libinotify-kqueue/libinotify-kqueue

It is used in this way in many other ports, including sysutils/conman, sysutils/incron, benchmarks/stress-ng, and comms/libusbmuxd. I tried to base my makefile off of what I saw in the ports tree already.
Comment 11 Quentin Baker 2021-08-10 20:50:10 UTC
Created attachment 227094 [details]
New diff with requested changes

Quick change - updated maintainer email to match bugzilla.
Comment 12 Guido Falsi freebsd_committer 2021-08-14 19:41:24 UTC
Created attachment 227193 [details]
Updated patch

Hi,

I have tested the port in poudriere and ran it.

I did make a few adjustments:

- Converted it to USE_GITLAB, the changes should be straightforward.

- The port was missing some build time dependencies:

USES=pkgconfig
USE_GNOME=intlrtool

Most probably you did not spot them because the usually happen to be already present on a live system. This kind of thing is why testing ports in poudriere is highly recommended.

Also, the pkg-descr file had a long text all in one line. The rules mandate for wrapping at 80 char length.


Apart from these things it looks fine.

I'd rather have you acknowledge my changes before committing it.

Thanks.
Comment 13 Quentin Baker 2021-08-15 06:27:36 UTC
Comment on attachment 227193 [details]
Updated patch

Thanks!
Comment 14 commit-hook freebsd_committer 2021-08-15 17:14:12 UTC
A commit in branch main references this bug:

URL: https://cgit.FreeBSD.org/ports/commit/?id=9bee84be4e46e59b7eaee39aced7fa0ed926a4c2

commit 9bee84be4e46e59b7eaee39aced7fa0ed926a4c2
Author:     Quentin Baker <bsd@quentb.com>
AuthorDate: 2021-08-15 17:10:45 +0000
Commit:     Guido Falsi <madpilot@FreeBSD.org>
CommitDate: 2021-08-15 17:12:28 +0000

    x11/xfce4-docklike-plugin: Add new port

    This is a taskbar panel plugin for xfce4, designed to mimic the look
    and functionality of docks and application bars used in Windows and
    MacOS. It includes optional features like window previews and launcher
    pinning.

    WWW: https://gitlab.xfce.org/panel-plugins/xfce4-docklike-plugin

    PR:             257692

 x11/Makefile                                       |  1 +
 x11/xfce4-docklike-plugin/Makefile (new)           | 37 ++++++++++++++++++++++
 x11/xfce4-docklike-plugin/distinfo (new)           |  3 ++
 .../files/patch-src_Helpers.cpp (new)              | 11 +++++++
 .../files/patch-src_Wnck.cpp (new)                 | 20 ++++++++++++
 x11/xfce4-docklike-plugin/pkg-descr (new)          |  6 ++++
 x11/xfce4-docklike-plugin/pkg-plist (new)          | 14 ++++++++
 7 files changed, 92 insertions(+)
Comment 15 commit-hook freebsd_committer 2021-08-15 17:23:15 UTC
A commit in branch main references this bug:

URL: https://cgit.FreeBSD.org/doc/commit/?id=9ea58709c15f52803be8a0c366b6744c91c3989a

commit 9ea58709c15f52803be8a0c366b6744c91c3989a
Author:     Guido Falsi <madpilot@FreeBSD.org>
AuthorDate: 2021-08-15 17:21:57 +0000
Commit:     Guido Falsi <madpilot@FreeBSD.org>
CommitDate: 2021-08-15 17:21:57 +0000

    Add Quentin Baker for x11/xfce4-docklike-plugin

    PR:             257692

 documentation/content/en/articles/contributors/contrib-additional.adoc | 1 +
 1 file changed, 1 insertion(+)
Comment 16 Guido Falsi freebsd_committer 2021-08-15 17:25:44 UTC
Port added. Thanks!